﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win.UltraWinSchedule.DayView;

namespace _138118
{
    class Mycreation:IUIElementCreationFilter
    {
        class OwnerStste
        {
            public bool draft ;
            public bool complete ;
        }
        public delegate void OnOwnerHeaderCheck(object sender, OwnerHeaderCheckBoxArg e);
        public event OnOwnerHeaderCheck OwnerHeaderCheck;

        Dictionary<Owner, OwnerStste> ownerState = new Dictionary<Owner, OwnerStste>();
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is OwnerHeaderUIElement)
            {
                OwnerHeaderUIElement owner = parent as OwnerHeaderUIElement;
                if (!ownerState.ContainsKey(owner.Owner))
                    ownerState.Add(owner.Owner, new OwnerStste() { complete = false, draft = false });


                CheckBoxUIElement chekComplete = new CheckBoxUIElement(parent);
                
                Point loc = parent.Rect.Location;
                loc.Offset(parent.Rect.Width - 80, 2);
                chekComplete.Rect = new System.Drawing.Rectangle(loc, new Size(80, parent.Rect.Height - 4));
                chekComplete.Text = "Complete";
                chekComplete.CheckState = ownerState[owner.Owner].complete ? System.Windows.Forms.CheckState.Checked : System.Windows.Forms.CheckState.Unchecked;
                chekComplete.ElementClick += chekComplete_ElementClick;
                parent.ChildElements.Add(chekComplete);

                CheckBoxUIElement chekDraft = new CheckBoxUIElement(parent);

                loc.Offset( - 50, 0);
                chekDraft.Rect = new System.Drawing.Rectangle(loc, new Size(50, parent.Rect.Height - 4));
                chekDraft.Text = "Draft";
                chekDraft.CheckState = ownerState[owner.Owner].draft ? System.Windows.Forms.CheckState.Checked : System.Windows.Forms.CheckState.Unchecked;
                chekDraft.ElementClick += chekDraft_ElementClick;
                parent.ChildElements.Add(chekDraft);

                TextUIElement ownerLabel = parent.GetDescendant(typeof(TextUIElement)) as TextUIElement;
                if (ownerLabel != null)
                {
                    ownerLabel.Rect = new Rectangle(parent.Rect.Location, ownerLabel.Rect.Size);
                }

            }
        }

        void chekDraft_ElementClick(object sender, UIElementEventArgs e)
        {
            CheckBoxUIElement c = (CheckBoxUIElement)e.Element;
            OwnerHeaderUIElement parent = (OwnerHeaderUIElement)e.Element.Parent;

             ownerState[parent.Owner].draft =  c.CheckState == System.Windows.Forms.CheckState.Checked   ? true : false;
            if (OwnerHeaderCheck != null)
                OwnerHeaderCheck.Invoke(sender, new OwnerHeaderCheckBoxArg(parent.Owner));
        }

        void chekComplete_ElementClick(object sender, UIElementEventArgs e)
        {
            CheckBoxUIElement c = (CheckBoxUIElement)e.Element;
            OwnerHeaderUIElement parent = (OwnerHeaderUIElement)e.Element.Parent;

             ownerState[parent.Owner].complete =  c.CheckState == System.Windows.Forms.CheckState.Checked   ? true : false;
            if (OwnerHeaderCheck != null)
                OwnerHeaderCheck.Invoke(sender, new OwnerHeaderCheckBoxArg(parent.Owner));
        }


        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        #endregion
    }

    public class OwnerHeaderCheckBoxArg : EventArgs
    {
        Owner o;
        public Owner Owner
        {
            get { return o; }
        }

        public OwnerHeaderCheckBoxArg(Owner owner)
        {
            this.o = owner;
        }
    }
}
